## spirv-llvm-translator-12 12.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)

set (BASE_LLVM_VERSION 12.0.0)
set(LLVM_SPIRV_VERSION ${BASE_LLVM_VERSION}.0)

option(LLVM_SPIRV_INCLUDE_TESTS
  "Generate build targets for the llvm-spirv lit tests."
  ${LLVM_INCLUDE_TESTS})

if (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)
  # check if we build inside llvm or not
  if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(LLVM_SPIRV_BUILD_EXTERNAL YES)
  endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
endif (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)

if(LLVM_SPIRV_BUILD_EXTERNAL)
  project(LLVM_SPIRV
    VERSION
      ${LLVM_SPIRV_VERSION}
    LANGUAGES
      CXX
      C
  )

  set(CMAKE_CXX_STANDARD 14)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  if(LLVM_SPIRV_INCLUDE_TESTS)
    set(LLVM_TEST_COMPONENTS
      llvm-as
      llvm-dis
    )
  endif(LLVM_SPIRV_INCLUDE_TESTS)

  find_package(LLVM ${BASE_LLVM_VERSION} REQUIRED
    COMPONENTS
      Analysis
      BitReader
      BitWriter
      Core
      Support
      TransformUtils
      ${LLVM_TEST_COMPONENTS}
  )
  set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${LLVM_CMAKE_DIR}
  )
  include(AddLLVM)
  include(HandleLLVMOptions)

  message(STATUS "Found LLVM: ${LLVM_VERSION}")

  find_program(CCACHE_EXE_FOUND ccache)
  if(CCACHE_EXE_FOUND)
    message(STATUS "Found ccache: ${CCACHE_EXE_FOUND}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  endif()
endif()

set(LLVM_SPIRV_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include)

add_subdirectory(lib/SPIRV)
add_subdirectory(tools/llvm-spirv)
if(LLVM_SPIRV_INCLUDE_TESTS)
  add_subdirectory(test)
endif(LLVM_SPIRV_INCLUDE_TESTS)

install(
  FILES
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVLib.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVOpts.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVExtensions.inc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/include/LLVMSPIRVLib
)

configure_file(LLVMSPIRVLib.pc.in ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc @ONLY)
install(
  FILES
    ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/lib${LLVM_LIBDIR_SUFFIX}/pkgconfig
)

=== lib/SPIRV/CMakeLists.txt ===
add_llvm_library(LLVMSPIRVLib
  LLVMToSPIRVDbgTran.cpp
  Mangler/FunctionDescriptor.cpp
  Mangler/Mangler.cpp
  Mangler/ManglingUtils.cpp
  Mangler/ParameterType.cpp
  OCLToSPIRV.cpp
  OCLTypeToSPIRV.cpp
  OCLUtil.cpp
  VectorComputeUtil.cpp
  SPIRVLowerBool.cpp
  SPIRVLowerConstExpr.cpp
  SPIRVLowerMemmove.cpp
  SPIRVLowerOCLBlocks.cpp
  SPIRVLowerSaddWithOverflow.cpp
  SPIRVLowerSPIRBlocks.cpp
  SPIRVReader.cpp
  SPIRVRegularizeLLVM.cpp
  SPIRVToLLVMDbgTran.cpp
  SPIRVToOCL.cpp
  SPIRVToOCL12.cpp
  SPIRVToOCL20.cpp
  SPIRVUtil.cpp
  SPIRVWriter.cpp
  SPIRVWriterPass.cpp
  PreprocessMetadata.cpp
  libSPIRV/SPIRVBasicBlock.cpp
  libSPIRV/SPIRVDebug.cpp
  libSPIRV/SPIRVDecorate.cpp
  libSPIRV/SPIRVEntry.cpp
  libSPIRV/SPIRVFunction.cpp
  libSPIRV/SPIRVInstruction.cpp
  libSPIRV/SPIRVModule.cpp
  libSPIRV/SPIRVStream.cpp
  libSPIRV/SPIRVType.cpp
  libSPIRV/SPIRVValue.cpp
  LINK_COMPONENTS
    Analysis
    BitWriter
    Core
    IRReader
    Linker
    Support
    TransformUtils
  DEPENDS
    intrinsics_gen
)

target_include_directories(LLVMSPIRVLib
  PRIVATE
    ${LLVM_INCLUDE_DIRS}
    ${LLVM_SPIRV_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/libSPIRV
    ${CMAKE_CURRENT_SOURCE_DIR}/Mangler
)

=== debian/changelog ===
spirv-llvm-translator-12 (12.0.0-4) unstable; urgency=medium

  * Restrict watch file to 12.* releases.
  * Enable all hardening flags.
  * Bump Standards-Version to 4.6.1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 15 May 2022 23:58:08 +0200

spirv-llvm-translator-12 (12.0.0-3) unstable; urgency=medium

  [ Timo Aaltonen ]
  * control: Bump debhelper to 13.
  * control: Bump policy to 4.6.0.
  * control: Drop lldb-12 from build-depends, it's not used and prevents
    build on mips/mipsel.

  [ Andreas Beckmann ]
  * rules: Parse llvm version from Build-Depends.
  * control: Set Rules-Requires-Root: no.
  * control, install: Multiarchify the packages.
  * upstream/metadata: Add.
  * copyright: Update/remove outdated file patterns.
  * Fix typo.
  * Update Lintian overrides.
  * Add myself to Uploaders.
  * Have one set of packages per llvm version:
    - Fork source package as spirv-llvm-translator-12.
    - Rename binary packages:
      + libllvmspirvlib-dev => libllvmspirvlib-12-dev,
      + llvm-spirv => llvm-spirv-12.
    - Rename /usr/bin/llvm-spirv to /usr/bin/llvm-spirv-12.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Feb 2022 20:05:39 +0100

spirv-llvm-translator (12.0.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 16 Aug 2021 09:59:48 +0300

spirv-llvm-translator (12.0.0-1) experimental; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 07 Jun 2021 12:24:54 +0300

spirv-llvm-translator (12.0~git20210212-2) experimental; urgency=medium

  * control: Fix libllvmspirvlib-dev depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 10 May 2021 12:17:08 +0300

spirv-llvm-translator (12.0~git20210212-1) experimental; urgency=medium

  * New upstream snapshot.
  * Build against llvm-12.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 12 Apr 2021 20:24:01 +0300

spirv-llvm-translator-11 (11.0.0-2) unstable; urgency=medium

  [ Timo Aaltonen ]
  * control: Bump debhelper to 13.
  * control: Bump policy to 4.6.0.
  * control: Drop lldb-11 from build-depends, it's not used and prevents
    build on mips/mipsel.

  [ Andreas Beckmann ]
  * rules: Parse llvm version from Build-Depends.
  * control: Set Rules-Requires-Root: no.
  * control, install: Multiarchify the packages.
  * upstream/metadata: Add.
  * copyright: Update/remove outdated file patterns.
  * Fix typo.
  * Update Lintian overrides.
  * Add myself to Uploaders.
  * Have one set of packages per llvm version:
    - Fork source package as spirv-llvm-translator-11.
    - Rename binary packages:
      + libllvmspirvlib-dev => libllvmspirvlib-11-dev,
      + llvm-spirv => llvm-spirv-11.
    - Rename /usr/bin/llvm-spirv to /usr/bin/llvm-spirv-11.
  * Allow overriding BASE_LLVM_VERSION.
  * Restrict watch file to 11.* releases.
  * Enable all hardening flags.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 11 Apr 2022 10:32:52 +0200

spirv-llvm-translator (11.0.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Mark -dev as M-A: same.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 20 Oct 2020 11:24:57 +0300

spirv-llvm-translator (11.0~git20200922-1) unstable; urgency=medium

  * New upstream snapshot.
  * Build against llvm-11.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 22 Sep 2020 19:45:26 +0300

spirv-llvm-translator (10.0.0-1) unstable; urgency=medium

  * New upstream release.
  * watch: Updated.
  * Build against llvm-10.
  * control: Use debhelper-compat, bump to 12.
  * control: Bump policy to 4.5.0.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 01 Apr 2020 20:44:04 +0300

spirv-llvm-translator (9.0.0-1) unstable; urgency=medium

  * New upstream release.
  * d/copyright: spirv.hpp is Expat.
  * Build with llvm-9.
  * patches: Dropped the only patch, applied upstream.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 24 Sep 2019 12:04:15 +0300

spirv-llvm-translator (8.0.1-1) unstable; urgency=medium

  * New upstream release.
  * rules: Set build type as 'Release'.
  * debian/patches: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 01 Aug 2019 10:06:44 +0300

spirv-llvm-translator (8.0.0+git20190314-1) experimental; urgency=medium

  * New upstream snapshot.
  * Build a shared library.
  * Package llvm-spirv.
  * Add patch to support clang block syntax.
  * rules: Drop rpath.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 20 Mar 2019 17:24:46 +0200

spirv-llvm-translator (8.0.0-3) experimental; urgency=medium

  * rules: Rebuild the archive index after stripping.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 15 Mar 2019 09:23:42 +0200

spirv-llvm-translator (8.0.0-2) experimental; urgency=medium

  * rules: Build with -fPIC.
  * rules: Strip the library.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 14 Mar 2019 23:53:32 +0200

spirv-llvm-translator (8.0.0-1) experimental; urgency=medium

  * Initial release (Closes: #921422)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 06 Feb 2019 01:40:18 +0200

=== debian/control ===
Source: spirv-llvm-translator-12
Section: libdevel
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 13),
 cmake,
 libclang-12-dev,
 llvm-12-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm12/master

Package: libllvmspirvlib12
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV -- shared library
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the shared library.

Package: libllvmspirvlib-12-dev
Architecture: any
Multi-Arch: same
Depends:
 libllvmspirvlib12 (= ${binary:Version}),
 ${misc:Depends}
Conflicts:
 libllvmspirvlib-x.y-dev,
Breaks:
 libllvmspirvlib-dev (<< 13.0.0-3~),
Replaces:
 libllvmspirvlib-dev (<< 13.0.0-3~),
 libllvmspirvlib-x.y-dev,
Provides:
 libllvmspirvlib-x.y-dev,
Description: bi-directional translator for LLVM/SPIRV -- development files
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes static libs and headers for development.

Package: llvm-spirv-12
Architecture: any
Depends:
 libllvmspirvlib12 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the llvm-spirv-12 binary.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS	 = hardening=+all

include /usr/share/dpkg/pkg-info.mk

LLVM_VERSION	 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)

%:
	dh $@ --builddir build/

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_SKIP_RPATH=ON \
		-DBUILD_SHARED_LIBS=ON \
		-Wno-dev

execute_after_dh_auto_build:
	$(MAKE) -C build llvm-spirv
	mv build/tools/llvm-spirv/llvm-spirv build/tools/llvm-spirv/llvm-spirv-$(LLVM_VERSION)

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spirv-llvm-translator-$1.tar.gz%" \
   https://github.com/KhronosGroup/SPIRV-LLVM-Translator/tags \
   (?:.*?/)?v?(12\.[\d.]*)\.tar\.gz
